<script>
	import "swiper/scss"
	import "swiper/css/lazy"

	import Card from "@/components/CarCard.svelte"
	import SVG from "@/components/svg.svelte"
	import { Lazy } from "swiper"
	import { Swiper, SwiperSlide } from "swiper/svelte"

	import { isLight } from "@/stores/static"
	import { page } from "$app/stores"
	import { isSmall, isPhone, isTablet, isDesktop, isWide, isLarge } from "@/stores/responsiveness"
	import { writable } from "svelte/store"

	export let carsProp

	let swiper
	const pageIndex = writable(0)

	$: slides = $isDesktop || $isWide || $isLarge ? 4 : $isTablet ? 3 : $isPhone && !$isSmall ? 2 : 1
	
	$: cars = $page.data[carsProp]
	$: total = Math.ceil(cars?.length / slides)

	const init = e => swiper = e.detail[0]

	const next = () => swiper?.slideNext()
	const prev = () => swiper?.slidePrev()
	const to = i => swiper?.slideTo(i)

	$: {
		if (swiper) {
			swiper.on("slideChange", e => {
				pageIndex.set( Math.ceil(e.activeIndex / slides) )
			})
		}
	}
</script>

{#if cars && cars.length}
<Swiper
	on:swiper={init}
	modules={[ Lazy ]}
	slidesPerView={1}
	slidesPerGroup={1}
	spaceBetween={17}
	watchSlidesProgress={true}
	lazy={true}
	breakpoints={{
		1024: {
			slidesPerView: 4,
			slidesPerGroup: 4
		},
		768: {
			slidesPerView: 3,
			slidesPerGroup: 3
		},
		550: {
			slidesPerView: 2,
			slidesPerGroup: 2
		}
	}}>
	{#each cars as car}
		<SwiperSlide>
			<Card car={car} lazyClass="swiper-lazy" />
		</SwiperSlide>
	{/each}
</Swiper>
{/if}
{#if total > 1}
	<div 
		class="navigation is-flex is-align-items-center is-justify-content-flex-start"
		class:dark={!$isLight}>
		<!-- svelte-ignore a11y-click-events-have-key-events -->
		<div 
			on:click={prev}
			class="arrow prev icon is-flex is-align-items-center is-justify-content-center">
			<SVG folder="icons" name="arrow-left"/>
		</div>
		<div class="pagination is-flex is-align-items-center is-justify-content-center">
			{#if total}
				{#each new Array(total) as _, i}
					<!-- svelte-ignore a11y-click-events-have-key-events -->
					<div 
						on:click='{() => to(i * slides)}'
						class:is-active={$pageIndex === i}
						class="pagination-item"></div>
				{/each}
			{/if}
		</div>
		<!-- svelte-ignore a11y-click-events-have-key-events -->
		<div 
			on:click={next} 
			class="arrow next icon is-flex is-align-items-center is-justify-content-center">
			<SVG folder="icons" name="arrow-right" />
		</div>
	</div>
{/if}

<style lang="scss">
.navigation {
	margin-top: .5rem;
	&.dark {
		.arrow {
			background: #2E2E2E;
			:global(svg path) {
				fill: $white;
			}
 		}
		.pagination {
			&-item {
				border-color: #D8D8D8;
				&.is-active {
					background: #D8D8D8;
				}
			}
		}
	}
}

.arrow {
	padding: 0 1rem;	
	background: $gray;
	cursor: pointer;
	transition: background .2s ease-in-out;
	:global(svg path) {
		transition: fill .2s ease-in-out;
	}
}

.pagination {
	margin: 0 1rem;
	&-item {
		width: .375rem;
		height: .2rem;
		border: .5px solid $gray-text;
		border-radius: 1px;
		transition: 
			background .2s ease-in-out,
			border-color .2s ease-in-out;
		cursor: pointer;
		&:not(:last-child) {
			margin-right: .625rem;
		}
		&.is-active {
			background: $gray-text;
		}
	}
}
</style>